#include <avr/io.h>

#include "spi.h"


void SPI_init(void)
{
	// set SPI direction: MOSI and SCK as output, MISO as input
	SPI_DDR |= (1 << SPI_MOSI) | (1 << SPI_SCK);
	SPI_DDR &= ~(1 << SPI_MISO);

	// initialize SPI
	DDRB |= 1 << PB4; // FS
	PORTB |= (1 << PB4); // FS = 1
	
	SPCR =  (1 << SPE) |			// enable
		(1 << MSTR) |			// master mode
		(0 << DORD) |			// MSB first
		(1 << CPOL) | (0 << CPHA) |	// mode 1
		(0 << SPR0) | (0 << SPR1);			// f_osc
	SPSR = (1 << SPI2X);			// f_osc x2
}

uint8_t SPI_exchange(uint8_t data)
{
	SPDR = data;
	//PORTD &= ~(1 << PD7);
	while(!(SPSR & (1 << SPIF))) {
		/*if ((SPCR & (1 << MSTR)) == 0)
			PORTD &= ~(1 << PD7);
		else PORTD |= 1 << PD7;*/
	}
	//PORTD |= (1 << PD7);
	return SPDR;
}

